/*!\file:  PatchesSize.cpp
 * \brief  determine size of patches from inputs
 */ 

#ifdef HAVE_CONFIG_H
	#include "config.h"
#else
#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
#endif

#undef __FUNCT__ 
#define __FUNCT__ "PatchesSize"

#include "./InputToResultx.h"
#include "../../DataSet/DataSet.h"

void PatchesSize(DataSet* elements,int* ppatch_numrows, int* ppatch_numcols,int enum_type){

	int i;

	/*output: */
	int patch_numrows;
	int patch_numcols;

	/*intermediary:*/
	Element* element=NULL;
	int count=0;
	int numcols=0;
	int max_numcols=0;

	/*Go through elemnets, and each time an element holds an input with the correct enum_type, increase count by 1. At the 
	 * same time, retrieve size of patch that this input will output, and during the loop, figure out the max of that patch size. 
	 * The final count will be the number of rows in the patches array, and max_numcols will be the number of columns of the 
	 * p[atches array: */
	 
	patch_numrows=0;
	patch_numcols=0;
	numcols=0;
	
	for(i=0;i<elements->Size();i++){

		element=(Element*)elements->GetObjectByOffset(i);
		element->PatchSize(&patch_numrows,&numcols,enum_type);
		if(numcols>patch_numcols)patch_numcols=numcols;

	}

	/*Assign output pointers:*/
	*ppatch_numrows=patch_numrows;
	*ppatch_numcols=patch_numcols;
}

